<template>
  <section class="game">
    <header>
      <div class="lobby-details">
        <h1 class="rc:text--title">{{ lobby.gameBox.name }}</h1>
        <button
          v-if="isCreator && !closure"
          class="abort-game"
          @click="gameState.abortGame()"
        >
          Abort game
        </button>
        <LobbyShareLink :lobby="lobby" />
        <div class="players">
          <span>Players:</span>
          <div
            class="player"
            v-for="it in lobby.participants.players.asList"
            :key="it.id"
            :class="[
              it.uiMeta?.classNames,
              { self: it.id === lobbyState.self.id },
            ]"
            :style="it.uiMeta?.styles"
          >
            {{ it.name }}
          </div>
        </div>
        <div class="spectators" v-if="lobby.participants.spectators.length > 0">
          <span>Spectators:</span>
          <div
            class="spectator"
            v-for="it in lobby.participants.spectators"
            :key="it.id"
            :class="[
              it.uiMeta?.classNames,
              { self: it.id === lobbyState.self.id },
            ]"
            :style="it.uiMeta?.styles"
          >
            {{ it.name }}
          </div>
        </div>
      </div>
      <ol class="game-logs" ref="gameLogsElement">
        <li v-for="log in logs" :key="log">
          {{ log?.message ?? "&nbsp;" }}
        </li>
      </ol>
    </header>
    <div v-if="closure" class="closure">
      Game resolved at
      <span class="time" :time="closure.endTime.toISOString()">
        {{ closure.endTime.toLocaleString() }}
      </span>
      <button class="back-to-lobby" type="button" @click="$emit('continue')">
        Back to lobby
      </button>
      <div class="group" v-for="group in closure.gameResultGroups" :key="group">
        <h2 class="rc:text--subtitle">{{ group.name }}</h2>
        <ul class="player-stats">
          <li
            class="stats"
            v-for="stats in group.stats"
            :key="stats"
            :class="{ self: stats.player.id === lobbyState.self.id }"
            :style="stats.player.uiMeta?.styles"
          >
            {{ stats.player.name }}
            <span v-if="stats.text"> – {{ stats.text }}</span>
          </li>
        </ul>
      </div>
    </div>
    <div class="zones">
      <Zone
        class="zone"
        v-for="zone in game.zones.asTree"
        :key="zone"
        :lobby-state="lobbyState"
        :game-state="gameState"
        :zone="zone"
      />
    </div>
    <div class="actions--global" v-if="globalActions.length > 0">
      <button
        class="action"
        type="button"
        v-for="action in globalActions"
        :key="action"
        v-tooltip:bottom.html="action.description"
        :disabled="!action.check()"
        @click="gameState.perform(action)"
      >
        {{ action.name }}
      </button>
    </div>
  </section>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  PropType,
  ref,
  watch,
  watchEffect,
} from "vue";
import LobbyShareLink from "@/modules/lobby/LobbyShare.vue";
import { UIGameState, UILobbyState } from "@raining.cards/client";
import { ElementType } from "@raining.cards/common";
import {
  useAllowedActions,
  useGameClosure,
  useGameLogs,
} from "@/modules/game/game.state";
import { useLobby } from "@/modules/lobby/lobby.state";
import { delay } from "@raining.cards/util";
import Zone from "@/modules/game/Zone.vue";

export default defineComponent({
  components: { LobbyShareLink, Zone },
  props: {
    lobbyState: {
      type: Object as PropType<UILobbyState>,
      required: true,
    },
    gameState: {
      type: Object as PropType<UIGameState>,
      required: true,
    },
  },
  emits: ["continue"],
  setup(props) {
    const lobby = useLobby(props.lobbyState);
    const game = computed(() => props.gameState.game);
    const logs = useGameLogs(props.gameState);
    const closure = useGameClosure(props.gameState);
    // todo move to core
    const isCreator = computed(
      () => lobby.value.creator.id === props.lobbyState.self.id
    );

    const allowedActions = useAllowedActions(props.gameState);
    const globalActions = computed(
      () => allowedActions.value[ElementType.GLOBAL][ElementType.GLOBAL]
    );

    const gameLogsElement = ref<HTMLElement>();

    watch(logs, () =>
      requestAnimationFrame(() =>
        gameLogsElement.value!.scrollTo({
          top: gameLogsElement.value!.scrollHeight,
        })
      )
    );

    watchEffect(() => props.gameState.on("deltaBulkStep", () => delay(75)));

    return {
      lobby,
      game,
      logs,
      gameLogsElement,
      closure,
      globalActions,
      isCreator,
    };
  },
});
</script>

<style lang="scss" scoped>
@import "!/styles/variables";
@import "!/styles/mixins";

.actions--global {
  display: flex;
  justify-content: center;
  margin: (-$spacing-md / 2) (-$spacing-lg / 2);

  > * {
    margin: ($spacing-md / 2) ($spacing-lg / 2);
  }
}

button.action,
.back-to-lobby {
  @include action-button;
  padding: $spacing-sm $spacing-md;
}

.abort-game {
  @include action-button;
  padding: $spacing-xs $spacing-sm;
  font-size: 0.8em;
}

header {
  margin-bottom: $spacing-xl;
  display: flex;

  > * {
    flex: 1;
  }
}

.lobby-share-link {
  font-size: 0.7rem;
  margin-bottom: $spacing-md;
}

.players,
.spectators {
  display: flex;

  > .player,
  > .spectator {
    flex: 0;
    opacity: 0.8;

    &.self {
      color: darkcyan;
    }
    &.turn {
      opacity: 1;
      font-weight: 500;
      &::before {
        content: "⤜";
        color: red;
      }
      &::after {
        content: "➛";
        color: red;
      }
    }
    &.defeated {
      text-decoration: line-through;
      opacity: 0.6;
    }
  }
}

.players {
  font-size: 0.85rem;
  margin: (-$spacing-md / 2);

  > * {
    margin: ($spacing-md / 2);
  }
}

.spectators {
  color: #555555;
  font-size: 0.75rem;
  margin: (-$spacing-sm / 2);

  > * {
    margin: ($spacing-sm / 2);
  }
}

@mixin scrollbar-color($handle-color, $bg-color) {
  scrollbar-color: $handle-color $bg-color;

  &::-webkit-scrollbar-track-piece {
    background-color: $bg-color;
  }
  &::-webkit-scrollbar-thumb {
    background-color: $handle-color;
  }
}

.game-logs {
  height: 4.9rem + $spacing-sm * 2;
  padding: $spacing-sm;
  align-self: flex-end;
  overflow-y: auto;
  text-align: center;
  background-color: #202c2f;
  font-size: 0.85rem;

  scrollbar-width: auto;
  &::-webkit-scrollbar {
    width: 15px;
    height: 15px;
  }
  @include scrollbar-color(#797822, transparent);

  > li {
    color: #fbf990;
    font-size: 0.72em;
    font-weight: 500;
    line-height: 1.3;
    opacity: 0.7;

    &:nth-child(N + 2) {
      font-size: 0.79em;
      opacity: 0.75;
    }

    &:nth-child(N + 3) {
      font-size: 0.86em;
      opacity: 0.8;
    }

    &:nth-child(N + 4) {
      font-size: 0.93em;
      opacity: 0.85;
    }

    &:nth-child(N + 5) {
      font-size: 1em;
      opacity: 0.9;
    }
  }
}

.closure {
  text-align: center;
  margin: $spacing-xl 0 $spacing-xxl;
  padding: $spacing-xl;
  background-color: $white;
  box-shadow: 0 0 6px 3px $primary-800;

  .time {
    font-family: monospace;
  }

  .back-to-lobby {
    display: block;
    margin: $spacing-lg auto;
  }

  .stats.self {
    color: darkcyan;
    font-weight: 600;
  }
}

.domains {
  margin-bottom: $spacing-lg;
  display: grid;
  grid-template-columns: 1fr;
  grid-gap: $spacing-md;

  @media (min-width: 1120px) {
    grid-template-columns: 1fr 1fr;
  }

  @media (min-width: 1680px) {
    grid-template-columns: 1fr 1fr 1fr;
  }
}
</style>
